Index: /trunk/BNC/src/bnccaster.cpp
===================================================================
--- /trunk/BNC/src/bnccaster.cpp	(revision 8920)
+++ /trunk/BNC/src/bnccaster.cpp	(revision 8921)
@@ -71,8 +71,9 @@
   if (port != 0) {
     _server = new QTcpServer;
+    _server->setProxy(QNetworkProxy::NoProxy);
     if ( !_server->listen(QHostAddress::Any, port) ) {
       QString message = "bncCaster: Cannot listen on sync port "
-                      + QByteArray::number(port)
-                      + " (Error Code: " + QByteArray::number(_server->serverError()) + ")";
+                      + QByteArray::number(port) + ": "
+                      + _server->errorString();
       emit newMessage(message.toLatin1(), true);
     }
@@ -88,8 +89,9 @@
   if (uPort != 0) {
     _uServer = new QTcpServer;
+    _uServer->setProxy(QNetworkProxy::NoProxy);
     if ( !_uServer->listen(QHostAddress::Any, uPort) ) {
       QString message = "bncCaster: Cannot listen on usync port "
-                      + QByteArray::number(uPort)
-                      + " (Error Code: " + QByteArray::number(_uServer->serverError()) + ")";
+                      + QByteArray::number(uPort) + ": "
+                      + _uServer->errorString();
       emit newMessage(message.toLatin1(), true);
     }
@@ -116,8 +118,9 @@
   if (!_miscMount.isEmpty() && _miscPort != 0) {
     _miscServer = new QTcpServer;
+    _miscServer->setProxy(QNetworkProxy::NoProxy);
     if ( !_miscServer->listen(QHostAddress::Any, _miscPort) ) {
       QString message = "bncCaster: Cannot listen on miscellaneous output port "
-                      + QByteArray::number(_miscPort)
-                      + " (Error Code: " + QByteArray::number(_miscServer->serverError()) + ")";
+                      + QByteArray::number(_miscPort) + ": "
+                      + _miscServer->errorString();
       emit newMessage(message.toLatin1(), true);
     }
Index: /trunk/BNC/src/bnccaster.h
===================================================================
--- /trunk/BNC/src/bnccaster.h	(revision 8920)
+++ /trunk/BNC/src/bnccaster.h	(revision 8921)
@@ -30,4 +30,5 @@
 #include <QTcpServer>
 #include <QTcpSocket>
+#include <QNetworkProxy>
 
 #include "satObs.h"
Index: /trunk/BNC/src/bnccore.cpp
===================================================================
--- /trunk/BNC/src/bnccore.cpp	(revision 8920)
+++ /trunk/BNC/src/bnccore.cpp	(revision 8921)
@@ -519,8 +519,9 @@
     delete _serverEph;
     _serverEph = new QTcpServer;
+    _serverEph->setProxy(QNetworkProxy::NoProxy);
     if ( !_serverEph->listen(QHostAddress::Any, _portEph) ) {
       QString message = "t_bncCore: Cannot listen on ephemeris port "
-                      + QByteArray::number(_portEph)
-                      + " (Error Code: " + _serverEph->serverError() + ")";
+                      + QByteArray::number(_portEph) + ": "
+                      + _serverEph->errorString();
       slotMessage(message.toLatin1(), true);
     }
@@ -538,8 +539,9 @@
     delete _serverCorr;
     _serverCorr = new QTcpServer;
+    _serverCorr->setProxy(QNetworkProxy::NoProxy);
     if ( !_serverCorr->listen(QHostAddress::Any, _portCorr) ) {
       QString message = "t_bncCore: Cannot listen on correction port "
-                      + QByteArray::number(_portCorr)
-                      + " (Error Code: " + _serverCorr->serverError() + ")";
+                      + QByteArray::number(_portCorr) + ": "
+                      + _serverCorr->errorString();
       slotMessage(message.toLatin1(), true);
     }
Index: /trunk/BNC/src/bncgetthread.cpp
===================================================================
--- /trunk/BNC/src/bncgetthread.cpp	(revision 8920)
+++ /trunk/BNC/src/bncgetthread.cpp	(revision 8921)
@@ -151,8 +151,9 @@
   if (nmeaPort != 0) {
     _nmeaServer = new QTcpServer;
+    _nmeaServer->setProxy(QNetworkProxy::NoProxy);
     if (!_nmeaServer->listen(QHostAddress::Any, nmeaPort)) {
       QString message = "bncCaster: Cannot listen on port "
-                      + QByteArray::number(nmeaPort)
-                      + " (Error Code: " + QByteArray::number(_nmeaServer->serverError()) + ")";
+                      + QByteArray::number(nmeaPort) + ": "
+                      + _nmeaServer->errorString();
       emit newMessage(message.toLatin1(), true);
     } else {