Index: trunk/BNC/src/bnchelp.html
===================================================================
--- trunk/BNC/src/bnchelp.html	(revision 8935)
+++ trunk/BNC/src/bnchelp.html	(revision 8936)
@@ -1503,5 +1503,5 @@
 from sitelogs. An HTTP or HTTPS link to a directory containing these skeleton files may be available through data
 field number 7 of the affected NET record in the source-table.
-See <a href="http://www.epncb.oma.be:80/stations/log/skl/brus.skl" target="_blank">http://www.epncb.oma.be:80/stations/log/skl/brus.skl</a>
+See <a href="https://igs.bkg.bund.de/root_ftp/IGS/station/rnxskl/BRUX00BEL.skl" target="_blank">https://igs.bkg.bund.de/root_ftp/IGS/station/rnxskl/BRUX00BEL.skl</a>
 for an example of a public RINEX header skeleton file for EPN station Brussels. Note that the download of RINEX
 skeleton files from HTTPS websites requires the exchange of client and/or server certificates.
Index: trunk/BNC/src/bncrinex.cpp
===================================================================
--- trunk/BNC/src/bncrinex.cpp	(revision 8935)
+++ trunk/BNC/src/bncrinex.cpp	(revision 8936)
@@ -217,7 +217,12 @@
   // Read the local file
   // -------------------
-  QFile skl(_sklName);
+  QFile skl(_localSklName), sklAlt(_localSklNameAlternative);
   if ( skl.exists() && skl.open(QIODevice::ReadOnly) ) {
     QTextStream in(&skl);
+    if (_sklHeader.read(&in) == success) {
+      readDone = true;
+    }
+  } else if ( sklAlt.exists() && sklAlt.open(QIODevice::ReadOnly) ) {
+    QTextStream in(&sklAlt);
     if (_sklHeader.read(&in) == success) {
       readDone = true;
@@ -372,5 +377,6 @@
   QString sklExt = settings.value("rnxSkel").toString();
   if (!sklExt.isEmpty()) {
-    _sklName = path + ID + distStr + "." + sklExt;
+    _localSklName            = path + ID           + distStr + "." + sklExt;
+    _localSklNameAlternative = path + ID.toLower() + distStr + "." + sklExt;
   }
 
Index: trunk/BNC/src/bncrinex.h
===================================================================
--- trunk/BNC/src/bncrinex.h	(revision 8935)
+++ trunk/BNC/src/bncrinex.h	(revision 8936)
@@ -68,5 +68,6 @@
    QString         _pgmName;
    QString         _userName;
-   QString         _sklName;
+   QString         _localSklName;
+   QString         _localSklNameAlternative;
    bool            _writeRinexFileOnlyWithSkl;
    bool            _rnxV3;
Index: trunk/BNC/src/bncwindow.cpp
===================================================================
--- trunk/BNC/src/bncwindow.cpp	(revision 8935)
+++ trunk/BNC/src/bncwindow.cpp	(revision 8936)
@@ -1309,5 +1309,5 @@
   _rnxIntrComboBox->setWhatsThis(tr("<p>Select the length of the RINEX Observation file. <i>[key: rnxIntr]</i></p>"));
   _rnxSamplComboBox->setWhatsThis(tr("<p>Select the RINEX Observation sampling interval in seconds. <i>[key: rnxSampl]</i></p>"));
-  _rnxSkelLineEdit->setWhatsThis(tr("<p>BNC allows using personal RINEX skeleton files that contain the RINEX header records you would like to include. You can derive a skeleton file from information given in an up to date sitelog.</p><p>A file in the RINEX Observations 'Directory' with a 'Skeleton extension' skl or SKL is interpreted by BNC as a personal RINEX header skeleton file for the corresponding stream. In case of 'SKL'/'skl' the 4/9-char ID forming the base name has to be written in upper cases. <i>[key: rnxSkel]</i></p>"));
+  _rnxSkelLineEdit->setWhatsThis(tr("<p>BNC allows using personal RINEX skeleton files that contain the RINEX header records you would like to include. You can derive a skeleton file from information given in an up to date sitelog.</p><p>A file in the RINEX Observations 'Directory' with a 'Skeleton extension' skl or SKL is interpreted by BNC as a personal RINEX header skeleton file for the corresponding stream. <i>[key: rnxSkel]</i></p>"));
   _rnxFileCheckBox->setWhatsThis(tr("<p>Tick check box 'Skeleton mandatory' in case you want that RINEX files are only produced if skeleton files are available for BNC. If no skeleton file is available for a particular source then no RINEX Observation file will be produced from the affected stream.</p><p>Note that a skeleton file contains RINEX header information such as receiver and antenna types. In case of stream conversion to RINEX Version 3, a skeleton file should also contain information on potentially available observation types. A missing skeleton file will therefore enforce BNC to only save a default set of RINEX 3 observation types. <i>[key: rnxOnlyWithSKL]</i></p>"));
   _rnxScrpLineEdit->setWhatsThis(tr("<p>Whenever a RINEX Observation file is finally saved, you may want to compress, copy or upload it immediately, for example via FTP. BNC allows you to execute a script/batch file to carry out such operation.</p><p>Specify the full path of a script or batch file. BNC will pass the full RINEX Observation file path to the script as command line parameter (%1 on Windows systems, $1 on Unix/Linux/Mac systems). <i>[key: rnxScript]</i></p>"));